function [h0,h1,h2,h0_,h1_,h2_,z0,z1,z2,z0_,z1_,z2_] = MakeBiframe

% Make Biframe example
% 
% [h0,h1,h2,h1_,h2_,h3,z0,z1,z2,z0_,z1_,z2_] = MakeBiframe;
% figure(1), plot_wlets(h0,h1,h2,z0,z1,z2);
% figure(2), plot_H(h0,h1,h2);
% figure(3), plot_wlets(h0_,h1_,h2_,z0_,z1_,z2_);

k1 = 1;
k2 = 4;
k0 = k1+k2;

[tmp,tmp2,ar] = maxflatI(k0,k2-1);
[tmp,tmp2,br] = maxflatI(k2,k0-1);
ar = 2*ar;
br = 2*symmod(br);

r = roots(ar);
k = imag(r) == 0;
a_ = poly(r(k));
a = poly(r(~k));
a_ = sqrt(2)*a_/sum(a_);
a = sqrt(2)*a/sum(a);

h0 = conv(blp(k0),a);
h0_ = conv(blp(k0),a_);

h1 = conv(blp(k1),conv(bhp(k2),modflip(a_)));
h1_ = conv(blp(k1),conv(bhp(k2),modflip(a)));

h0_ = [h0_ 0 0];
h1 = -[h1 0 0];

% scale h1 and h1_ so they have the same norm. (not actually nec.)
no1 = norm(h1);
no1_ = norm(h1_);
h1 = h1*sqrt(no1_/no1);
h1_ = h1_*sqrt(no1/no1_);

% check:
f0 = h0; f0(1:2:end) = -f0(1:2:end);
f1 = h1; f1(1:2:end) = -f1(1:2:end);

[conv(f0,h0_)' conv(f1,h1_)']
conv(f0,h0_) + conv(f1,h1_)

cr = br - conv(blp(2*k1),symmod(ar));
cr = cr(2:end-1);

r = roots(cr);
k = imag(r) == 0;
c = poly(r(k));
c_ = poly(r(~k));

c_ = -sqrt(2)*c_/polyval(c_,-1);
c = sqrt(2)*c/polyval(c,-1);


% check:
conv(c,c_) - cr

c = [0 c 0];

h2 = conv(bhp(k2),c)/sqrt(2);
h2_ = conv(bhp(k2),c_)/sqrt(2);

h2 = [-h2 0];
h2_ = [-h2_ 0];


r0 = conv(h0,h0_);
r1 = conv(h1,h1_);
r2 = conv(h2,h2_);
t0 = r0 + r1 + 2*r2


f0 = -h0; f0(1:2:end) = -f0(1:2:end);
f1 = -h1; f1(1:2:end) = -f1(1:2:end);
r0 = conv(f0,h0_);
r1 = conv(f1,h1_);
t1 = r0 + r1 

H = [h0' h1' h2']
G = [h0_' h1_' h2_']




z0 = [-ones(k0,1); roots(a)];
z1 = [-ones(k1,1); ones(k2,1); -1./roots(a_)];
z2 = [ones(k2,1); roots(c)];


z0_ = [-ones(k0,1); roots(a_)];
z1_ = [-ones(k1,1); ones(k2,1); -1./roots(a)];
z2_ = [ones(k2,1); roots(c_)];



return



for n = 1:10
    fprintf('%d ',n-1);
    fprintf(' & %f ',h0(n));
    fprintf(' & %f ',h1(n));
    fprintf(' & %f ',h2(n));
    fprintf(' & %f ',h0_(n));
    fprintf(' & %f ',h1_(n));
    fprintf(' & %f ',h2_(n));
    fprintf(' \\cr \n');
end



if 1
    % FOR USE WITH PERIODIC EXTENSION PROGRAMS
h0 = [h0 0 0];
h1 = [0 0 h1];
h2 = [0 h2 0];
h0_ = [0 0 0 h0_(1:9)];
h1_ = [0 h1_ 0];
h2_ = [0 0 h2_];
H = [ h0' h1' h2'  h0_' h1_' h2_']
end



