function y = modflip(x)
%
% y = modflip(x)
% x must be column or a row vector.
%
%  X(z) = x(0) + x(1)/z + x(2)/z^2 + x(N-1)/z^N
%  Y(z) = X(-1/z) z^(-N) where N = deg{X}

N = length(x);

x(2:2:N) = -x(2:2:N);   % change sign of every second element
			% keep sign of first element the same.

y = x(N:-1:1);		% flip the order.


