function plot_iterfilt(h0,h1,h2,titlestring)

[H2,w] = freqz(h2);
[H1,w] = freqz(h1);

clf
plot(w/pi, abs(H1).^2 , 'r', w/pi, abs(H2).^2 , 'b')
set(gca,'fontsize',8)
hold on

f{1}{1} = h0;
f{2}{1} = h1;
f{3}{1} = h2;

J = 3;
for j = 2:J
    for i = 1:3
        f{i}{j} = conv(h0,up(f{i}{j-1},2));
    end
    [H1,w] = freqz(f{2}{j});
    [H2,w] = freqz(f{3}{j});
    plot(w/pi,abs(H1).^2,'r',w/pi,abs(H2).^2,'b')
end
[H0,w] = freqz(f{1}{j});
plot(w/pi,abs(H0).^2,'k');

if nargin > 3
	title(titlestring)
else
	title('3-STAGE ITERATED FILTERS')
end
xlabel('\omega/ \pi')

xlabel('\omega')
axis([0 1 0 10])
set(gca,'xtick',[0 0.25 0.5 0.75  1]);
set(gca,'FontName','Symbol')
set(gca,'xtickLabel',{'0','0.25 p','0.5 p','0.75 p','p'})
orient portrait


