function w = hddwt_sym(x, J, af);

% HIGHER-DENSITY DISCRETE WAVELET TRANSFORM
%    with symmetric extensions
% w = hddwt_sym(x,J,h0,h1,h2);
% INPUT
%   x  : input signal
%   J  : number of stages
%   h0 : lowpass analysis filter
%   h1 : bandpass analysis filter
%   h2 : highpass analysis filter
% OUTPUT
%   w  : wavelet coefficients

for j = 1:J
    [x, w{j}{1} w{j}{2}] = afb_sym(x, af);
end
w{J+1} = x;