function y = ihddwt(w, J, sf);

% INVERSE HIGHER-DENSITY DISCRETE WAVELET TRANSFORM
% y = ihddwt(w, J, sf);
% INPUT
%   w : wavelet coefficients
%   J : number of stages
%  sf : synthesis filters
% OUTPUT
%   y : output signal

y = w{J+1};
for j = J:-1:1
    y = sfb(y, w{j}{1}, w{j}{2}, sf);
end