

% Example

[af, sf] = filters('4vm');
[af, sf] = filters('1vm');
[af, sf] = filters('3vm');
[af, sf] = filters('bi4');

N = 16;
x = randn(1,N);

% TEST ANALYSIS/SYNTHESIS FILTER BANK
[lo, bp, hi] = afb(x, af);
y = sfb(lo, bp, hi, sf);
error = max(abs(x-y))

% HIGHER-DENSITY DISCRETE WAVELET TRANSFORM
x = rand(1,64);
J = 3;
w = hddwt(x, J, af);
y = ihddwt(w, J, sf);
err = x - y;
max(abs(err))


% --- test symmetric extension programs --- 

% TEST ANALYSIS/SYNTHESIS FILTER BANK
[af, sf] = filters_sym;
[lo, bp, hi] = afb_sym(x, af);
y = sfb_sym(lo, bp, hi, sf);
error = max(abs(x-y))

% HIGHER-DENSITY DISCRETE WAVELET TRANSFORM
x = rand(1,64);
J = 3;
w = hddwt_sym(x, J, af);
y = ihddwt_sym(w, J, sf);
err = x - y;
max(abs(err))


